

Application create: #PrisioneroApp with:
    (#( AbtViewApplication)
        collect: [:each | Smalltalk at: each ifAbsent: [
            Application errorPrerequisite: #PrisioneroApp missing: each]])!

PrisioneroApp becomeDefault!
Object subclass: #PrisionObject
    instanceVariableNames: 'handlers '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionObject subclass: #GUIObject
    instanceVariableNames: 'model coordinator '
    classVariableNames: 'ImageCache '
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIObject subclass: #GUIController
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIController subclass: #ConnectController
    instanceVariableNames: 'source destination '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIController subclass: #DefaultController
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIController subclass: #MoveController
    instanceVariableNames: 'moved '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
MoveController subclass: #AlignController
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIController subclass: #RemoveController
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIObject subclass: #GUIView
    instanceVariableNames: 'boundingBox '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIView subclass: #GUIComposite
    instanceVariableNames: 'parts '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIComposite subclass: #CasinoGUI
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
GUIView subclass: #LugarGUI
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
LugarGUI subclass: #FactoryGUI
    instanceVariableNames: 'rate counter classes '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
FactoryGUI subclass: #CasaDelTesoroGUI
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
FactoryGUI subclass: #PuertaGUI
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
LugarGUI subclass: #MesaDeJuegosGUI
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
MesaDeJuegosGUI subclass: #MesaDelPrisioneroGUI
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
LugarGUI subclass: #PasilloGUI
    instanceVariableNames: 'layout '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionObject subclass: #PrisionCoordinator
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionObject subclass: #PrisionModel
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionModel subclass: #Actor
    instanceVariableNames: 'lugar '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Actor subclass: #Banca
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Banca subclass: #BancaDeCartas
    instanceVariableNames: 'mazo apuestas '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
BancaDeCartas subclass: #BancaDelPrisionero
    instanceVariableNames: 'caudales '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Actor subclass: #Jugador
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Jugador subclass: #JugadorDeCartas
    instanceVariableNames: 'cartas '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDeCartas subclass: #JugadorDelPrisionero
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDelPrisionero subclass: #Aleatorio
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDelPrisionero subclass: #AlgoCooperador
    instanceVariableNames: 'contador '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDelPrisionero subclass: #Cooperador
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDelPrisionero subclass: #Desertor
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDelPrisionero subclass: #DondeLasDanLasToman
    instanceVariableNames: 'ultimaJugada '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
DondeLasDanLasToman subclass: #CandidoProbador
    instanceVariableNames: 'contador '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
JugadorDelPrisionero subclass: #Rencoroso
    instanceVariableNames: 'defraudado '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionModel subclass: #Carta
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Carta subclass: #CartaDelPrisionero
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
CartaDelPrisionero subclass: #Cooperar
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
CartaDelPrisionero subclass: #Desertar
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionModel subclass: #Casino
    instanceVariableNames: 'creditos lugares '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
PrisionModel subclass: #Lugar
    instanceVariableNames: 'contenedor actores vecinos '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Lugar subclass: #LugarNoHabitable
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
LugarNoHabitable subclass: #CasaDelTesoro
    instanceVariableNames: 'dineroEntregado '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
LugarNoHabitable subclass: #Pared
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
LugarNoHabitable subclass: #Puerta
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Lugar subclass: #MesaDeJuegos
    instanceVariableNames: 'banca '
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
MesaDeJuegos subclass: #MesaDelPrisionero
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Lugar subclass: #Pasillo
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Object subclass: #Random
    instanceVariableNames: 'esRandom '
    classVariableNames: 'Default '
    poolDictionaries: ''!

PrisioneroApp becomeDefault!
Application subclass: #PrisioneroApp
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!


PrisioneroApp becomeDefault!

!Actor publicMethods !

cohabitantes
	"Devuelve los actores que se encuentran en el mismo lugar que el receptor."

	| result |
	result := Set new.
	self lugar notNil ifTrue: [
		result addAll: self lugar actores
	].
	^result
		remove: self ifAbsent: [];
		yourself!

congestionSoportada
	"Devuelve la congestion soportada por el receptor.
	Debe ser un numero mayor de cero que determinara que el receptor no se mueva si hay mucha gente en un pasillo."

	^5 "se mueve si en el pasillo hay hasta este numero de personas"!

esBanca
	"Devuelve true si el receptor es una Banca."

	^false!

esJugador
	"Devuelve true si el receptor es un jugador."

	^false!

is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self implementedBySubclass!

is: aState with: puntaje
	"Deve devolver true si el receptor esta en el estado aState teniendo este puntaje.
	Los posibles states son:
		#shy : boca en posicion normal :^|
		#amazed : boca abierta, gritando :^O
		#frown : aflijido :^(
		#smile : sonriendo :^)

		#normal : ojos en posicion normal :^)
		#upset : ojos sorprendidos =^)
		#mad : ojos enojados >^)
	La accion default es devolver siempre true en #shy o #normal
	Las subclases pueden refinar este metodo.
	"

	aState = #normal ifTrue: [ ^true ]. "Solo usaremos iconos para gestos normales;
		aunque las subclases pueden manejar ademas #upset y #mad "

	puntaje > 10000 ifTrue: [ ^aState = #tongue ].
	puntaje > 1000 ifTrue: [ ^aState = #smile ].
	puntaje > 500 ifTrue: [ ^aState = #amazed ].
	puntaje < 50 ifTrue: [ ^aState = #frown ].
	^aState = #shy!

lugar
	"Returns the instance var of the receiver
	 for external manipulation"
	^lugar!

lugar: aLugar
	"Mueve el receptor a aLugar."

	| anterior |
	lugar == aLugar ifTrue: [^self].
	anterior := lugar. lugar := aLugar.
	anterior notNil ifTrue: [ anterior salio: self ].
	aLugar notNil ifTrue: [ aLugar llego: self ].!

movilidad
	"Devuelve un indice de movilidad para el receptor.
	Debe ser un numero entre 0 y 1."

	^0.05 "se mueve el 1% de las veces"!

privateLugar: aPuerta
	" NO USAR - Fuerza el lugar del receptor a aPuerta. "

	lugar := aPuerta.!

puedeMoverseA: unLugar
	"El receptor puede moverse, en este momento, a unLugar si asi lo desea.
	Alli sera aceptado si lo hace ahora... mas tarde las cosas pueden cambiar.
	La accion default es moverse (a veces) si no esta jugando.
	Este metodo puede ser refinado por las subclases. "

	unLugar estaLleno ifTrue: [ ^self ].

	(self lugar esMesa
	and: [self lugar puedeJugar])
	ifTrue: [ ^self ]. "esta comodo jugando"

	(self deseaMoverseA: unLugar)
	ifTrue: [ self lugar: unLugar ]!

quiereJugarEn: aMesa
	"Devuelve true si el receptor desea jugar en aMesa.
	La accion default es responder siempre que si.
	Este metodo puede ser refinado por las subclases."

	^true!

vecinos
	"Devuelve los actores que se encuentran en los lugares vecinos al receptor."

	| result |
	result := Set new.
	self lugar notNil ifTrue: [
		self lugar vecinos do: [:each|
			result addAll: each actores
		]
	].
	^result! !

!Actor privateMethods !

deseaMoverseA: unLugar
	" Private - Accion basica de voluntad de moverse a un lugar. "

	"se movera si el lugar no esta muy lleno y muy de vez en cuando"
	^(unLugar actores size <= self congestionSoportada
	or: [ self lugar actores size >= unLugar actores size ])
	and: [ 1 - self movilidad < self nextRandom ]! !

!Aleatorio privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^(self randomize: self cartas) first! !

!AlgoCooperador publicMethods !

contador
	"Returns the instance var of the receiver
	 for external manipulation"

	contador isNil ifTrue: [ self initializeContador ].
	^contador!

contador: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	contador := anObject! !

!AlgoCooperador privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self quiereCooperar
	ifTrue: [ self cooperar ]
	ifFalse: [ self desertar ]!

initializeContador
	" Private - Initializes the receiver's contador"

	contador := 0.!

quiereCooperar
	" Private - El receptor devuelve true el 90% de las veces. "

	self contador: self contador + 1 \\ 10.
	^self contador = 0! !

!AlignController publicMethods !

align: parts to: object
	"Alinea las partes en parts con respecto a object."

	object isNil | parts isEmpty ifTrue: [ ^nil ].
	self
		alignHorizontal: parts to: object;
		alignVertical: parts to: object;
		yourself!

clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	| parts object |
	super clicked: aPane.
	object := self objectUnderCursor.
	object canBeMoved ifFalse: [ ^self ].
	parts := self model parts select: [:each| each isKindOf: object class ].
	self
		align: parts to: object;
		updateView;
		yourself.! !

!AlignController privateMethods !

alignHorizontal: parts to: object
	" Private - Alinea horizontalmente las partes en parts con respecto a object."

	| min max x |
	min := object left. max := object right.
	parts do: [:each|
		(each center x between: min and: max)
		ifTrue: [ each centerAt: object center x @ each center y ]
	]!

alignVertical: parts to: object
	" Private - Alinea verticalmente las partes en parts con respecto a object."

	| min max x |
	min := object top. max := object bottom.
	parts do: [:each|
		(each center y between: min and: max)
		ifTrue: [ each centerAt: each center x @ object center y ]
	]! !

!Banca publicMethods !

abrirJuego
	"Abre el juego para la mesa."

	self implementedBySubclass.!

apuestas
	"Devuelve las apuestas que estan sobre el receptor,
	como una colecction de pares #( jugador apuesta ). "

	self implementedBySubclass.!

casino
	"Devuelve el casino donde esta el receptor."

	^self mesa casino!

cerrarJuego
	"Cierra el juego para la mesa.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

congestionSoportada
	"Devuelve la congestion soportada por el receptor.
	Debe ser un numero mayor de cero que determinara que el receptor no se mueva si hay mucha gente en un pasillo."

	^15 "se mueve si en el pasillo hay hasta este numero de personas"!

esBanca
	"Devuelve true si el receptor es una Banca."

	^true!

evaluarApuestas
	"Evalua las apuestas realizadas en la mesa."

	self implementedBySubclass.!

finalizarRonda
	"Cierra una ronda para la mesa.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases"!

iniciarRonda
	"Cierra una ronda para la mesa.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases"!

is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self implementedBySubclass!

mesa
	"Devuelve el lugar donde esta el receptor."

	^self lugar!

movilidad
	"Devuelve un indice de movilidad para el receptor.
	Debe ser un numero entre 0 y 1."

	^0.05 "se mueve el 5% de las veces"!

notificarApuestas
	"Notifica las apuestas realizadas en la mesa."

	self implementedBySubclass.!

permitirA: aJugador apostarEn: aMesa
	"Permite que aJugador haga sus apuestas en aMesa."

	aJugador apostarEn: aMesa.!

permitirApostar
	" El receptor debe permitir apostar a los jugadores. "

	self mesa jugadores do: [:jugador| self permitirA: jugador apostarEn: self mesa ].!

puedeMoverseA: unLugar
	"El receptor puede moverse, en este momento, a unLugar si asi lo desea.
	Las bancas ocupan su lugar en una mesa libre. "

	unLugar esMesa ifTrue: [
		"unLugar estaVacio ifTrue: [ ^false ]."
		unLugar necesitaUnaBanca ifTrue: [ ^self lugar: unLugar ].
		^self
	].

	(self deseaMoverseA: unLugar)
	ifTrue: [ self lugar: unLugar ]! !

!BancaDeCartas class privateMethods !

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		addAll: #( repartiendo mezclando );
		yourself! !

!BancaDeCartas publicMethods !

abrirJuego
	"Abre el juego para la mesa."

	apuestas := Dictionary new.
	self
		mezclar;
		repartir!

aceptarApuesta: aCarta de: aJugador
	" Registra aCarta como una apuesta del jugador aJugador para la ronda actual. "

	apuestas at: aJugador put: aCarta.
	aCarta haSidoJugadaPor: aJugador en: self mesa.!

apuestas
	"Devuelve una copia de las apuestas que estan sobre el receptor. "

	apuestas isNil ifTrue: [ ^Array new ].
	^apuestas copy!

finalizarRonda
	"Cierra una ronda para la mesa."

	apuestas := nil.!

mazo
	"Returns the instance var of the receiver
	 for external manipulation"

	mazo isNil ifTrue: [ self initializeMazo ].
	^mazo!

notificarApuestas
	"Notifica las apuestas realizadas en la mesa."

	| jugadores apuesta |
	jugadores := apuestas keys asArray.
	jugadores do: [:aJugador|
		apuesta := apuestas at: aJugador.
		(jugadores copyWithout: aJugador)
		do: [:each|
			each
				jugador: aJugador
				aposto: apuesta
		]
	].! !

!BancaDeCartas privateMethods !

entregar: count cartasA: aJugador usando: aStream
	" Private - Entrega count cartas a aJugador obteniendolas del stream aStream (el cual debe ser un stream de cartas).
	En caso de acabarse las cartas no entregara mas cartas."

	count timesRepeat: [
		aStream atEnd ifFalse: [
			aJugador tomarCarta: aStream next
		]
	]!

initializeMazo
	" Private - Initializes the receiver's mazo"

	mazo := self implementedBySubclass.!

mezclar
	" Private - Mezcla las cartas del mazo.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases. "

	self triggerEvent: #mezclando!

repartir
	" Private - Reparte las cartas a los jugadores. "

	self triggerEvent: #repartiendo.
	self mesa jugadores do: [:aJugador| self repartirCartasA: aJugador ]!

repartirCartasA: aJugador
	" Private - Reparte cartas del mazo a aJugador. "

	self implementedBySubclass! !

!BancaDelPrisionero publicMethods !

castigo: aJugador
	"El receptor debera castigar a aJugador."

	self
		multarA: aJugador
		con: (self casino
			puntajeDeCastigo: aJugador
			en: self mesa).!

caudales
	"Returns the instance var of the receiver
	 for external manipulation"

	caudales isNil ifTrue: [ caudales := 0 ].
	^caudales!

cerrarJuego
	"Cierra el juego para la mesa."

	super cerrarJuego.

	"Quita las cartas de la mesa"
	self mesa jugadores do: [:aJugador|
		aJugador cartas: nil.
	].!

evaluarApuestas
	"Evalua las apuestas realizadas en la mesa."

	| jugadores yo tu miApuesta tuApuesta |
	jugadores := self mesa jugadores asArray.
	yo := jugadores first.
	miApuesta := apuestas at: yo.

	tu := jugadores last.
	tuApuesta := apuestas at: tu.

	miApuesta = tuApuesta
	ifTrue: [
		miApuesta esCooperar
		ifTrue: [ self recompensa: yo; recompensa: tu ]
		ifFalse: [ self castigo: yo;castigo: tu ]
	]
	ifFalse: [
		miApuesta esCooperar
		ifTrue: [ self incauto: yo; tentacion: tu ]
		ifFalse: [ self tentacion: yo; incauto: tu ]
	]!

incauto: aJugador
	"El receptor debera multar a aJugador por incauto."

	self
		multarA: aJugador
		con: (self casino
			puntajeDelIncauto: aJugador
			en: self mesa).!

is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self is: aState with: self caudales // 5  "para la banca las cosas son mas graves si no tiene dinero"!

movilidad
	"Devuelve un indice de movilidad para el receptor.
	Debe ser un numero entre 0 y 1."

	^self tieneDinero
	ifTrue: [
		(self lugar esMesa ifTrue: [1] ifFalse: [7]) "le gustan mas los pasillos (para permitir llegar a mesas lejanas)"
		* super movilidad
	]
	ifFalse: [ super movilidad * 17 ] "Se mueve mas rapido (corre) si necesita dinero"!

puedeMoverseA: unLugar
	"El receptor puede moverse, en este momento, a unLugar si asi lo desea."

	unLugar esMesa ifTrue: [
		self tieneDinero ifFalse: [ ^false ].
	].
	^super puedeMoverseA: unLugar!

quiereJugar
	"Devuelve true si el receptor desea jugar en alguna aMesa."

	^self tieneDinero!

quiereJugarEn: aMesa
	"Devuelve true si el receptor desea jugar en aMesa."

	self quiereJugar ifTrue: [ ^super quiereJugarEn: aMesa ].

	"El receptor no tiene suficiente dinero;
	 por eso saldra de la mesa en la que se encuentra."
	aMesa = self lugar
	ifTrue: [ self lugar: self lugar algunVecino ].

	^false!

recompensa: aJugador
	"El receptor debera recompensar a aJugador."

	self
		recompensarA: aJugador
		con: (self casino
			puntajeDeRecompensa: aJugador
			en: self mesa).!

tentacion: aJugador
	"El receptor debera premiar a aJugador por tentarse con exito."

	self
		recompensarA: aJugador
		con:  (self casino
			puntajeDeTentacion: aJugador
			en: self mesa).!

tieneDinero
	"Devuelve true si el receptor tiene dinero como jugar en alguna aMesa."

	^self caudales >= self caudalesMinimos! !

!BancaDelPrisionero privateMethods !

caudalesMinimos
	" Private - Devuelve los caudales que son considerados minimos para seguir jugando. "

	^self casino caudalesMinimos!

deseaMoverseA: unLugar
	" Private - Accion basica de voluntad de moverse a un lugar. "

	(unLugar isKindOf: CasaDelTesoro)
	ifTrue: [
		" solo si el receptor no tiene suficiente dinero entrara en la casa del tesoro a buscar mas..."
		self caudalesMinimos * 3 > self caudales ifTrue: [ ^true ].
		"Por ahora haremos que siempre desee entrar para permitir recaudaciones.
		^true "
	].

	(unLugar esMesa and: [unLugar necesitaUnaBanca])
	ifTrue: [ ^true ].

	(unLugar actores detect: [:one| one species = self species ] ifNone: [])
	notNil ifTrue: [ ^false ].

	^super deseaMoverseA: unLugar!

initializeCaudales
	" Private - Initializes the receiver's caudales"

	caudales := self casino caudalesDeInicioPara: self.!

initializeMazo
	" Private - Initializes the receiver's mazo. "

	mazo := Array    "Solo usamos dos cartas."
		with: Cooperar new
		with: Desertar new!

mezclar
	" Private - Mezcla las cartas del mazo.
	En el juego del prisionero no se mezclan las cartas,
	 sino que siempre les son entregadas las dos mismas cartas a los jugadores. "!

multarA: aJugador con: puntos
	" Private - Multa a aJugador con puntos. "

	aJugador multa: puntos.
	self registrarPuntaje: puntos negated para: aJugador.!

recompensarA: aJugador con: puntos
	" Private - Recompensa a aJugador con puntos. "

	aJugador recibir: puntos.
	self registrarPuntaje: puntos para: aJugador.!

registrarPuntaje: delta para: aJugador
	" Private - Registra un cambio de puntaje para aJugador. "

	self casino registrarPuntaje: delta para: aJugador.
	caudales := caudales - delta.!

repartirCartasA: aJugador
	" Private - Reparte cartas del mazo a aJugador. "

	aJugador cartas: self mazo copy. "se le reparten todas las cartas."

	"Otra forma de hacerlo...
	self entregar: 2 cartasA: aJugador usando: (ReadStream on: self mazo)
	"! !

!CandidoProbador publicMethods !

contador
	"Returns the instance var of the receiver
	 for external manipulation"

	contador isNil ifTrue: [ self initializeContador ].
	^contador!

contador: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	contador := anObject!

multa: puntaje
	"El receptor debe aceptar la multa del puntaje que se le otorga.
	El receptor se siente defraudado si alguna vez es multado."

	super multa: puntaje.
	self defraudado: true.! !

!CandidoProbador privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	| aJugar |
	^(aJugar = self cooperar and: [ self quiereCooperar ])
	ifTrue: [ aJugar ] ifFalse: [ self desertar ]!

initializeContador
	" Private - Initializes the receiver's contador"

	contador := 0.!

quiereCooperar
	" Private - El receptor devuelve true a veces. "

	self contador: self contador + 1 \\ 7.
	^self contador = 0! !

!Carta publicMethods !

haSidoJugadaPor: aJugador en: aMesa
	"El receptor ha sido jugada en aMesa por aJugador.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."! !

!CartaDelPrisionero publicMethods !

= otraCarta
	"Las cartas del Prisionero son solo Cooperar y Desertar."

	^self class == otraCarta class!

esCooperar
	"Devuelve true is el receptor indica cooperacion."

	^false!

esDesertar
	"Devuelve true is el receptor indica desercion."

	^false! !

!CasaDelTesoro publicMethods !

dineroEntregado
	"Returns the instance var of the receiver
	 for external manipulation"

	dineroEntregado isNil ifTrue: [ self initializeDineroEntregado ].
	^dineroEntregado!

dineroEntregado: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	dineroEntregado := anObject!

esNecesarioCrearBancas
	"Devuelve true si el receptor detecta que es necesaria alguna banca mas en el casino."

	^self casino seNecesitanBancas!

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento."

	^unActor esBanca!

step
	"Da un paso en la simulacion del receptor.
	Si el receptor tiene vecinos con bancas sin dinero;
		las atraera con lo que aumenta su superficie efectiva
		de contacto con el casino."

	super step.
	self vecinos notEmpty ifTrue: [
		self vecinos do: [:aLugar|
			(aLugar actores select: [:each| each esBanca and: [each tieneDinero not]])
			do: [:necesitada| necesitada lugar: self ].
		].
	].! !

!CasaDelTesoro privateMethods !

initializeDineroEntregado
	" Private - Initializes the receiver's dineroEntregado"

	dineroEntregado := 0.!

llego: unActor
	" Private - unActor llego al receptor. "

	unActor esBanca ifTrue: [ self preparar: unActor ].
	^super llego: unActor!

nuevaBanca: unaBanca
	" Private - unaBanca ha sido creada en receptor. "

	unaBanca lugar: self.
	"Terminal bell."!

preparar: aBanca
	" Private - Llena el bolsillo de aBanca con dinero. "

	self dineroEntregado: self dineroEntregado + aBanca caudales.
	aBanca initializeCaudales.
	self dineroEntregado: self dineroEntregado - aBanca caudales.!

salio: unActor
	" Private - unActor salio del receptor. "

	unActor esBanca ifTrue: [ self preparar: unActor ].
	^super salio: unActor! !

!CasaDelTesoroGUI privateMethods !

createElement
	" Private - Creates a new jugador."

	| anElement |
	self model esNecesarioCrearBancas
	ifTrue: [
		anElement := self basicCreateElement.
		anElement notNil ifTrue: [ self model nuevaBanca: anElement ].
	].!

initializeClasses
	" Private - Initializes the receiver's classes"

	classes := OrderedCollection with: #BancaDelPrisionero!

initializeRate
	" Private - Initializes the receiver's rate"

	rate := 3. "cada rate pasos en la simulacion crea un elemento."! !

!Casino publicMethods !

add: aLugar
	"Agrega al receptor aLugar."

	^self lugares add: aLugar!

caudalesDeInicioPara: aBanca
	"Devuelve los caudales con los que debera arrancar aBanca."

	^self puntajeDefault * 10!

donacionDe: aJugador a: otro de: puntaje
	"Efectua la donacion de un determinado puntaje de aJugador a otro.
	Devuelve la cantidad de puntaje donado."

	| donacion |
	"aJugador podra donar tanto como tenga hasta llegar a sus caudales de inicio."
	donacion := puntaje min: (self puntajeDe: aJugador) - self puntajeDefault.
	donacion > 0 ifFalse: [ ^0 ]. "No puede donarse una deuda..."
	self
		registrarPuntaje: donacion negated para: aJugador;
		registrarPuntaje: donacion para: otro;
		yourself.
	^donacion!

jugadores
	"Devuelve todos los jugadores que estan dentro del receptor."

	^self creditos keys!

lugares
	"Returns the instance var of the receiver
	 for external manipulation"

	lugares isNil ifTrue: [ self initializeLugares ].
	^lugares!

lugares: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	lugares := anObject!

procreo: aJugador
	" unJugador desea procrear.
	Verifica que este pueda hacerlo.
	Devolvera el hijo si tiene exito; sino devuelve nil."

	| costo |
	(self puedeProcrear: aJugador) ifFalse: [ ^nil ].
	costo := self puntajeMinimoParaProcrear - self puntajeDefault.
	self registrarPuntaje: costo negated para: aJugador.
	^aJugador species new
		lugar: aJugador lugar;
		yourself!

puedeProcrear: unJugador
	" Devolvera true si unJugador puede procrear ahora. "

	^unJugador lugar estaLleno not
	and: [ (self puntajeDe: unJugador) > self puntajeMinimoParaProcrear ]!

puntajeDe: unJugador
	"Devuelve el puntaje actual del jugador aJugador."

	^self creditos at: unJugador ifAbsent: [ self puntajeDefault ]!

puntajeDeCastigo: aJugador en: aMesa
	"El receptor devuelve que puntaje debe cobrarse para castigar a aJugador"

	^10!

puntajeDefault
	"Devuelve el puntaje inicial de unJugador."

	^300!

puntajeDelIncauto: aJugador en: aMesa
	"El receptor devuelve que puntaje debe cobrarse para castigar al incauto aJugador"

	^100!

puntajeDeRecompensa: aJugador en: aMesa
	"El receptor devuelve que puntaje debe pagarse para recompenzar aJugador"

	^300.!

puntajeDeTentacion: aJugador en: aMesa
	"El receptor devuelve que puntaje debe pagarse por tentarse en buen momento a aJugador"

	^500.!

puntajeMinimoParaProcrear
	" Devuelve el minimo puntaje para procrear. "

	^self puntajeDefault * 3!

puntajes
	"Devuelve todos los jugadores con sus puntajes."

	| result |
	result := SortedCollection sortBlock: [:a :b| a nombre <= b nombre ].
	result addAll: self jugadores.
	^result asArray collect: [:each|
		Array with: each with: (self puntajeDe: each)
		]!

puntuaciones
	"Devuelve la tabla de puntuaciones."

	^self puntajes collect: [:tuple|
		Array with: tuple first nombre with: tuple last
	]!

remove: aModel
	"Remueve un lugar de los actuales."

	aModel esJugador ifTrue: [
		creditos removeKey: aModel ifAbsent: [ ^false ].
		^true
	].

	aModel esLugar ifTrue: [
		aModel vecinos do: [:each|
			each vecinos remove: aModel ifAbsent: []
		].
		self lugares remove: aModel ifAbsent: [ ^false ].
	].

	^true!

seNecesitanBancas
	"Devuelve true si no hay bancas suficientes como para atender todas las mesas."

	| mesasSinBanca bancasPaseando |
	mesasSinBanca := bancasPaseando := 0.
	self lugares do: [:each|
		each esMesa
		ifTrue: [
			each necesitaUnaBanca
			ifTrue: [ mesasSinBanca := mesasSinBanca + 1 ]
		]
		ifFalse: [
			bancasPaseando := bancasPaseando
				+ (each actores select: [:one| one esBanca ]) size
		]
	].
	^mesasSinBanca > bancasPaseando! !

!Casino privateMethods !

caudalesMinimos
	" Private - Devuelve los caudales que son considerados minimos para seguir jugando. "

	^self puntajeDefault // 10!

creditos
	" Private - Devuelve la coleccion de creditos.
	Este mensaje no debe ser usado por otros objetos."

	creditos isNil ifTrue: [ self initializeCreditos ].
	^creditos!

initializeCreditos
	" Private - Initializes the receiver's creditos"

	creditos := Dictionary new.!

initializeLugares
	" Private - Initializes the receiver's lugares"

	lugares := Set new.!

registrarPuntaje: delta para: aJugador
	" Private - Registra un cambio de puntaje para aJugador.
	Devuelve el puntaje que queda para ajugador. "

	| nuevoPuntaje |
	nuevoPuntaje := (self puntajeDe: aJugador) + delta.
	self creditos at: aJugador put: nuevoPuntaje.
	aJugador puntaje: nuevoPuntaje.
	^nuevoPuntaje! !

!CasinoGUI publicMethods !

addPart: aPart
	"Agrega una parte al receptor."

	super addPart: aPart.
	self model add: aPart model.!

canBeMoved
	"El receptor nopuede moverse graficamente."

	^false!

casino
	"El casino es el modelo del receptor."

	^self model!

displayWith: aPen
	"Display the receiver with aPen."

	aPen isNil ifTrue: [ ^self ].
	self boundingBox: aPen boundingBox.
	^super displayWith: aPen!

initializeModel
	"Initialize the receiver with a default model."

	self model: Casino new.!

model
	"Returns the instance var of the receiver
	 for external manipulation"

	model isNil ifTrue: [ self initializeModel ].
	^model!

model: aModel
	"The model of the receiver will be changed to aModel."

	super model: aModel.
	self checkParts.!

newCasaDelTesoro
	"Permite al usuario crear una CasaDelTesoro en el modelo.
	Devuelve una GUI a la CasaDelTesoro creada."

	| casa casaGUI |
	casa := CasaDelTesoro en: self casino.
	casaGUI := GUIView for: casa in: self coordinator.
	casaGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: casaGUI.
	^casaGUI!

newMesa
	"Permite al usuario crear una nueva mesa en el modelo.
	Devuelve una GUI a la mesa creada."

	| aClass mesa mesaGUI |
	aClass := self class oneOf: MesaDeJuegos allSubclasses.
	aClass isNil ifTrue: [ ^nil ].
	mesa := aClass en: self casino.
	mesaGUI := GUIView for: mesa in: self coordinator.
	mesaGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: mesaGUI.
	^mesaGUI!

newPasillo
	"Permite al usuario crear un nuevo pasillo en el modelo.
	Devuelve una GUI al pasillo creada."

	| aClass pasillo pasilloGUI |
	aClass := self class oneOf: Pasillo withAllSubclasses.
	aClass isNil ifTrue: [ ^nil ].
	pasillo := aClass en: self casino.
	pasilloGUI := GUIView for: pasillo in: self coordinator.
	pasilloGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: pasilloGUI.
	^pasilloGUI!

newPuerta
	"Permite al usuario crear una puerta de entrada en el modelo.
	Devuelve una GUI a la puerta creada."

	| puerta puertaGUI |
	puerta := Puerta en: self casino.
	puertaGUI := GUIView for: puerta in: self coordinator.
	puertaGUI centerAt: self coordinator graphPane mouseLocation.
	self addPart: puertaGUI.
	^puertaGUI!

remove: aGUIObject
	"Elimina aGUIObject del receptor."

	self model remove: aGUIObject model.
	self parts remove: aGUIObject.! !

!CasinoGUI privateMethods !

checkParts
	" Private - El receptor debera checkear sus partes para garantizar que todas representan una vista del modelo. "

	| lugares toRemove |
	lugares := self model lugares copy.
	toRemove := Set new.
	self parts do: [:each|
		lugares
			remove: each model
			ifAbsent: [ "esta GUI es obsoleta"
				toRemove add: each
			]
	].
	self parts removeAll: toRemove.
	"los lugares que quedaron no tienen GUI."
	self addParts: (lugares collect: [:each| GUIView for: each in: self ]).! !

!ConnectController publicMethods !

button1Down: aPane
	"El mouse se ha presionado sobre aPane.
	Detecta el objeto a mover."

	super button1Down: aPane.
	source := self objectUnderCursor.
	(self canConnect: source) ifFalse: [ ^source := nil ].
	self mark: source.!

button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane."

	super button1Moved: aPane.
	source notNil ifTrue: [
		self mark: destination.
		destination := self objectUnderCursor.
		(self canConnect: source to: destination)
		ifTrue: [ self mark: destination ]
		ifFalse: [ destination := nil ]
	].!

canConnect: anObject
	"Returns true if the receiver can connect anObject."

	^anObject model respondsTo: #vecinos!

canConnect: anObject to: another
	"Returns true if the receiver can connect anObject to another."

	^(self canConnect: another)
	and: [ anObject ~= another
	and: [ anObject model puedeSerVecinoDe: another model ]]!

clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	super clicked: aPane.
	self button1Moved: aPane.
	self mark: source.
	(source notNil and: [ destination notNil ])
	ifTrue: [ self connect: source to: destination ].
	source := destination := nil.!

connect: anObject to: another
	"Connect anObject to another."

	(anObject model lindaCon: another model)
	ifTrue: [
		(self confirm: anObject model printString ,' y ',another model printString
			,'\Ya han sido conectados...\\Seguro desea desconectarlos ?'withCrs)
		ifFalse: [ ^self ].
		anObject model vecinos remove: another model ifAbsent: [].
		another model vecinos remove: anObject model ifAbsent: [].
	]
	ifFalse: [
		anObject model vecinos add: another model.
		another model vecinos add: anObject model.
	].
	self updateView.!

displaySelectionIn: aPane
	"El receptor puede mostrar la seleccion actual en aPane."

	| color aPen lugares dest |
	super displaySelectionIn: aPane.

	aPen := aPane pen.
	color := aPen foreColor.
	lugares := self lugares.
	lugares do: [:each|
		each model vecinos do: [:vecino|
			dest := lugares detect: [:one| one model = vecino].
			aPen
				foreColor: (each species == dest species
					ifTrue: ["ClrBlue" 16777232 "Color blue"]
					ifFalse: ["ClrDarkblue" 16777220 "Color darkBlue"]);
				place: each center;
				goto: dest center
		].
	].
	aPen foreColor: color.! !

!ConnectController privateMethods !

lugares
	" Private - Devuelve los lugaresGUI del receptor. "

	^self model parts! !

!Cooperador privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self cooperar! !

!Cooperar publicMethods !

esCooperar
	"El receptor indica cooperacion."

	^true! !

!DefaultController publicMethods !

doubleClicked: aPane
	"Se ha dobleclickeado sobre aPane."

	self objectUnderCursor model inspect.! !

!Desertar publicMethods !

esDesertar
	"El receptor indica desercion."

	^true! !

!Desertor privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self desertar! !

!DondeLasDanLasToman publicMethods !

jugador: aJugador aposto: aCarta
	"El receptor es notificado de la apuesta que ha realizado aJugador en la mesa en la que esta jugando."

	ultimaJugada := aCarta! !

!DondeLasDanLasToman privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^ultimaJugada isNil
	ifTrue: [ self cooperar ]
	ifFalse: [ ultimaJugada ]! !

!FactoryGUI publicMethods !

classes
	"Returns the instance var of the receiver
	 for external manipulation"

	classes isNil ifTrue: [ self initializeClasses ].
	^classes!

counter
	"Returns the instance var of the receiver
	 for external manipulation"

	counter isNil ifTrue: [ self initializeCounter ].
	^counter!

counter: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	counter := anObject!

image
	" Returns the receiver's background image. "

	^self imageNamed: self model class name!

rate
	"Returns the instance var of the receiver
	 for external manipulation"

	rate isNil ifTrue: [ self initializeRate ].
	^rate!

rate: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	rate := anObject!

reset
	"Force reset of the receiver."

	classes := nil.!

step
	"Da un paso en la simulacion del receptor."

	super step.
	self rate = 0 ifTrue: [ ^self ].
	self counter: self counter + 1.
	self counter > self rate
	ifTrue: [
		self
			createElement;
			counter: 0
	].! !

!FactoryGUI privateMethods !

basicCreateElement
	" Private - Creates a new element from receiver's classes."

	| aName aClass |
	self classes isEmpty ifTrue: [ ^nil ].
	aName := self classes removeFirst.
	aClass := Smalltalk at: aName asSymbol ifAbsent: [ ^nil ].
	self classes addLast: aName.
	^aClass new!

clearRate
	" Private - Clear the receiver's rate"

	rate := 0.!

createElement
	" Private - Create a new element. "

	^self implementedBySubclass!

decrementRate
	" Private - Reduces the receiver's rate"

	self rate: (self rate - 1 max: 0).!

incrementRate
	" Private - Increment the receiver's rate"

	self rate: self rate + 1!

initializeClasses
	" Private - Initializes the receiver's classes"

	^self implementedBySubclass!

initializeCounter
	" Private - Initializes the receiver's counter"

	counter := 0.!

initializeRate
	" Private - Initializes the receiver's rate"

	rate := 7. "cada rate pasos en la simulacion crea un elemento."! !

!GUIComposite publicMethods !

addPart: aPart
	"Agrega una parte al receptor."

	self parts add: aPart.!

addParts: aCollection
	"Agrega una coleccion de partes al receptor."

	aCollection do: [:each| self addPart: each ].!

coordinator: anObject
	"Sets the coordinator of the receiver."

	super coordinator: anObject.
	self parts do: [:each| each coordinator: anObject ].!

parts
	"Returns the instance var of the receiver
	 for external manipulation"

	parts isNil ifTrue: [ self initializeParts ].
	^parts!

step
	"Da un paso en la simulacion del receptor."

	super step.
	self parts do: [:each| each step ].!

whoContains: aPoint
	"Devuelve el receptor si aPoint esta contenido en el, sino devuelve nil.
	Considera que aPoint puede estar sobre una parte del receptor."

	| result |
	(super whoContains: aPoint) isNil ifTrue: [ ^nil ].
	self parts do: [:aPart|
		result := aPart whoContains: aPoint.
		result notNil ifTrue: [ ^result ].
	].
	^self "aPoint esta sobre el fondo."! !

!GUIController publicMethods !

button1Down: aPane
	"El mouse se ha presionado sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

displaySelectionIn: aPane
	"El receptor puede mostrar la seleccion actual en aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

doubleClicked: aPane
	"Se ha dobleclickeado sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

mouseMoved: aPane
	"El mouse se ha movido sobre aPane.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."! !

!GUIController privateMethods !

canInspectModel
	" Private - Devuleve true si el usuario puede inspeccionar el modelo. "

	^self model notNil and: [ self model respondsTo: #inspect ].!

inspectModel
	" Private - Permite al usuario inspeccionar el modelo. "

	self model inspect.!

inspectObject
	" Private - Permite al usuario inspeccionar el objeto bajo el cursor o el modelo. "

	| object |
	object := self objectUnderCursor.
	object notNil
	ifTrue: [ object model inspect ]
	ifFalse: [ self inspectModel ]! !

!GUIObject class publicMethods !

imageCache
	"Returns the instance var of the receiver
	 for external manipulation"

	ImageCache isNil ifTrue: [ self initializeImageCache ].
	^ImageCache!

imageNamed: aName
	"Devuelve una imagen de nombre aName.
	Genra un error si no ha sido encontrada."

	^self imageNamed: aName ifAbsent: [ self error: 'Imagen no encontrada', aName ]!

imageNamed: aName ifAbsent: aBlock
	"Devuelve una imagen de nombre aName.
	Evalua aBlock si no ha sido encontrada."

	| image |
	^self imageCache
	at: aName
	ifAbsent: [
		image := self
			loadImageNamed: aName
			ifAbsent: [ ^aBlock value ].
		self imageCache at: aName put: image
	]!

loadImageNamed: aName ifAbsent: aBlock
	"Devuelve una imagen de nombre aName.
	Evalua aBlock si no ha sido encontrada.

	ATENCION: La imagen sera buscada en el direcotrio
	 de imagenes que cuelga del directorio default..."

	| fileName pathName |
	fileName := (self adaptFileName: aName),'.Bmp'.
	pathName := 'images\',fileName.
	^CgWinBMPFileFormat new loadFromFile: pathName!

on: aModel
	"Devuelve una instancia del receptor trabajando sobre aModel."

	^self new
		model: aModel;
		yourself! !

!GUIObject class privateMethods !

adaptFileName: aName
	" Private - Adapt aName as a valid file name.
		GUIObject adaptFileName: 'CasaDelTesoro-shy'

	No changes for VisualAGE because it supports long fileNames...
	"

	^aName
	"
	| transform result stream word |
	transform := Dictionary new.
	transform
		at: 'banca' put: 'b';
		at: 'amazed' put: 'z';
		at: 'normal' put: 'n';
		at: 'tongue' put:  't';
		at: 'smile' put: 's';
		at: 'upset' put: 'up';
		at: 'casadeltesoro' put: 'CT';
		at: 'cooperar' put: 'coo';
		at: 'desertar' put: 'des';
		yourself.
	result := String new.
	stream := ReadStream on: aName asString.
	[stream atEnd] whileFalse: [
		word := stream upTo: $-.
		result := result,(transform at: word asLowerCase ifAbsent: [word]).
		stream atEnd ifFalse: [ result := result,'-' ].
	].
	^result
	"!

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		add: #modelHasChanged;
		yourself!

initializeImageCache
	" Private - Initializes the receiver's imageCache"

	ImageCache := Dictionary new.! !

!GUIObject publicMethods !

coordinator
	"Returns the instance var of the receiver
	 for external manipulation"
	^coordinator!

coordinator: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	coordinator := anObject!

fileOutSurrogate: anObjectFiler
	" Answer surrogate for object filing after performing any dump preprocessing. "

	| surrogate |
	surrogate := super fileOutSurrogate: anObjectFiler.
	^surrogate copy
		privateCoordinator: nil;
		yourself!

imageNamed: aName
	"Devuelve una imagen de nombre aName.
	Genra un error si no ha sido encontrada."

	^self class imageNamed: aName!

imageNamed: aName ifAbsent: aBlock
	"Devuelve una imagen de nombre aName.
	Evalua aBlock si no ha sido encontrada."

	^self class imageNamed: aName ifAbsent: aBlock!

initMenu
	"Este metodo esta implementado para soportar que el receptor sea owner de menues."!

mark: anObject
	"Marca graficamente el objeto anObject."

	anObject isNil ifTrue: [ ^self ].
	anObject isRectangle ifFalse: [ ^self mark: anObject boundingBox ].
	self coordinator graphPane pen reverse: anObject!

model
	"Returns the instance var of the receiver
	 for external manipulation"
	^model!

model: aModel
	"Sets the instance var of the receiver with aModel."

	model := aModel.
	self triggerEvent: #modelHasChanged.
	aModel when: aModel changedEventName send: #update to: self.!

updateView
	"Update the view."

	self coordinator updateView! !

!GUIObject privateMethods !

mouseLocation
	" Private - Devuelve la posicion del cursor."

	^self coordinator mouseLocation!

objectUnderCursor
	" Private - Devuelve el objeto bajo el cursor."

	^self coordinator objectUnderCursor!

privateCoordinator: anObject
	" Private - Sets the instance var of the receiver."

	coordinator := anObject! !

!GUIView class publicMethods !

for: aModel in: aCoordinator
	"Devuelve una instancia del receptor apta para manejar aModel
	o nil si nadie puede manejarlo."

	| aClass |
	aClass := self withAllSubclasses
		detect: [:one| one instancesCanHandle: aModel ]
		ifNone: [ ^nil ].
	^(aClass on: aModel)
		coordinator: aCoordinator;
		yourself! !

!GUIView class privateMethods !

checkInstances
	" Private - Checkea las instancias del receptor.
	GUIView allSubclasses do: [:each| each checkInstances ]
	"

	self allInstances do: [:each| each check ].!

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		add: #boundsChanged;
		yourself!

instancesCanHandle: aModel
	" Private - Debe devolver true si las instancias del receptor pueden manejar aModel.
	La accion default es responder true si el nombre de la clase del modelo
	 concuerda en parte con el del receptor.
	Este mensaje puede ser refinado por las subclases. "

	^(aModel class name,'GUI') = self name! !

!GUIView publicMethods !

backColor
	"Returns the receiver's floor color."

	^"ClrDarkred" 16777217 "Color darkRed"!

bottom
	"Returns the bottom coordinate of the receiver."

	^self boundingBox bottom!

boundingBox
	"Returns the instance var of the receiver
	 for external manipulation"

	boundingBox isNil ifTrue: [ self initializeBoundingBox ].
	^boundingBox!

boundingBox: aRectangle
	"Sets the instance var of the receiver.
	Returns nil if the boundingBox is not changed."

	boundingBox = aRectangle ifTrue: [ ^nil ].
	self privateBoundingBox: aRectangle.
	self triggerEvent: #boundsChanged.!

canBeMoved
	"El receptor puede negarse a moverse graficamente.
	La accion default es ser siempre movible
	Este metodo puede ser refinado por las subclases."

	^true!

center
	"Devuelve el centro del area del receptor."

	^self boundingBox center!

centerAt: aPoint
	"Mueve el centro del area del receptor a aPoint."

	self boundingBox moveTo: aPoint - (self extent // 2)!

clone
	"Devuelve un clon del receptor."

	^self copy
		privateBoundingBox: self boundingBox deepCopy;
		model: self model clone;
		yourself!

containsPoint: aPoint
	"Devuelve true si aPoint esta contenido en el receptor."

	^self boundingBox containsPoint: aPoint!

defaultBoundingBox
	" Devuleve el boundingBox default para el receptor.
	Este metodo puede ser refinado por las subclases."

	^0@0 extent: self defaultExtent!

defaultExtent
	"Devuelve el extent default para el receptor."

	^self imageExtent!

displayWith: aPen
	"Display the receiver with aPen."

	aPen isNil ifTrue: [ ^self ].
	self exposedAreas do: [:area|
		aPen fill: area color: self backColor.
	].
	self parts do: [:each|
		each displayWith: aPen
	].!

extent
	"Returns the extent of the receiver."

	^self boundingBox extent!

height
	"Returns the height of the receiver."

	^self boundingBox height!

image
	"Returns the receiver's image.
	The default action is to return nil.
	This method can be refined by subclasses."

	^nil!

imageExtent
	"Devuelve el extent de la imagen del receptor.
	Si no tiene imagen devuelve 0@0"

	^self image notNil
	ifTrue: [ self image extent ]
	ifFalse: [ 0@0 ]!

isTransparent
	"Returns true if the receiver is transparent.
	By default the receiver is opaque."

	^false!

left
	"Returns the left coordinate of the receiver."

	^self boundingBox left!

leftBottom
	"Returns the leftBottom coordinate of the receiver."

	^self boundingBox leftBottom!

leftTop
	"Returns the leftTop coordinate of the receiver."

	^self boundingBox leftTop!

privateBoundingBox: aRectangle
	"Sets the instance var of the receiver."

	boundingBox := aRectangle.!

right
	"Returns the right coordinate of the receiver."

	^self boundingBox right!

rightBottom
	"Returns the rightBottom coordinate of the receiver."

	^self boundingBox rightBottom!

step
	"Da un paso en la simulacion del receptor."

	super step.
	self parts do: [:each| each step ].!

top
	"Returns the top coordinate of the receiver."

	^self boundingBox top!

update
	"Update the receiver."

	self coordinator updateView: self.!

whoContains: aPoint
	"Devuelve el receptor si aPoint esta contenido en el, sino devuelve nil.
	Considera que aPoint puede estar sobre una parte del receptor."

	| result |
	(super whoContains: aPoint) isNil ifTrue: [ ^nil ].
	self parts do: [:aPart|
		result := aPart whoContains: aPoint.
		result notNil ifTrue: [ ^result ].
	].
	^self "aPoint esta sobre el fondo."!

width
	"Returns the width of the receiver."

	^self boundingBox width! !

!GUIView privateMethods !

check
	" Private - El receptor puede checkear su arquitectura y ''arreglarse'' si asi lo desea."

	self model release.
	self model: self model. "reconnect the model"!

exposedAreas
	" Private - Returns the areas not covered by the parts. "

	| remaining opaques areas |
	remaining := Array with: self boundingBox.
	opaques := (self parts
		select: [:each| each isTransparent not ])
		collect: [:part| part boundingBox ].
	opaques do: [:opaque|
		areas := Set new.
		remaining do: [:each|
			(opaque intersects: each)
			ifTrue: [ areas addAll: (each nonIntersections: opaque) ]
			ifFalse: [ areas add: each ]
		].
		remaining := areas.
	].
	^remaining!

initializeBoundingBox
	" Private - Initializes the receiver's boundingBox"

	boundingBox := self defaultBoundingBox.! !

!Jugador class privateMethods !

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		addAll: #(
			premiado multado
			cambioPuntaje:
		);
		yourself! !

!Jugador publicMethods !

apostarEn: aMesa
	"El jugador ahora puede apostar en aMesa.
	Este metodo debe ser implementado por las subclases."

	^self implementedBySubclass!

donar: puntaje a: unJugador
	"El receptor intentara dar una cantidad de puntaje a aJugador."

	^self lugar donacionDe: self a: unJugador de: puntaje!

esJugador
	"Devuelve true si el receptor es un jugador."

	^true!

is: aState
	"Deve devolver true si el receptor esta en el estado aState."

	^self is: aState with: self puntaje!

multa: puntaje
	"El receptor debe aceptar la multa del puntaje que se le otorga.
	La accion default es no hacer nada.
	Es responsabilidad del receptor acordarse cuanto tiene.
	Este metodo puede ser refinado por las subclases."

	self triggerEvent: #multado.!

nombre
	"El receptor debera devolver su nombre.
	La accion default es devolver el nombre de la clase del receptor.
	Este mensaje puede ser refinado por las subclases."

	^self class name!

procrear
	"Si el receptor tiene puntaje suficiente, podra invertir parte de este en tener un hijo.
	El hijo sera de la misma especie (clase) del receptor y poseera un puntaje basico;
	 si el receptor desea darle mas dinero lo podra hacer mediante una donacion (ver #donar:a: ).
	El puntaje minimo para procrear esta dado en Casino>>#puntajeMinimoParaProcrear
	 y el costo esta dado por (puntajeMinimoParaProcrear - puntajeDefault)
	Este metodo devuelve el hijo creado en el mismo lugar donde se encuentra su padre,
	  aunque ambos no se 'conoceran'. Este metodo puede ser refinado por las subclases para mantener contactos familiares.
	"

	^self lugar procreo: self!

puedeProcrear
	"Devuelve true cuando el receptor puede procrear."

	^self lugar puedeProcrear: self!

puntaje
	"Devuelve el puntaje del receptor."

	^self lugar puntajeDe: self!

puntaje: puntaje
	"El receptor es notificado de su puntaje actual.
	ATENCION: esto NO cambia el puntaje del receptor.
		No es responsabilidad de este mantener su puntaje (aunque podria hacerlo si lo quisiera...).
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."

	self triggerEvent: #cambioPuntaje: with: puntaje!

recibir: puntaje
	"El receptor debe recibir el puntaje que se le otorga.
	La accion default es no hacer nada.
	Es responsabilidad del receptor acordarse cuanto tiene.
	Este metodo puede ser refinado por las subclases."

	self triggerEvent: #premiado! !

!JugadorDeCartas class privateMethods !

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		add: #tomandoCarta:;
		yourself! !

!JugadorDeCartas publicMethods !

cartas
	"Returns the instance var of the receiver
	 for external manipulation"

	cartas isNil ifTrue: [ self initializeCartas ].
	^cartas!

cartas: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	cartas := anObject!

jugador: aJugador aposto: aCarta
	"El receptor es notificado de la apuesta que ha realizado aJugador en la mesa en la que esta jugando.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."!

tomarCarta: aCarta
	"El receptor debera tomar aCarta en su poder."

	self triggerEvent: #tomandoCarta: with: aCarta.
	^self cartas add: aCarta! !

!JugadorDeCartas privateMethods !

initializeCartas
	" Private - Initializes the receiver's cartas"

	cartas := OrderedCollection new.! !

!JugadorDelPrisionero publicMethods !

apostarEn: aMesa
	"El jugador ahora puede apostar en aMesa."

	| aCarta |
	aMesa banca
		aceptarApuesta: (aCarta := self cartaAJugarEn: aMesa)
		de: self.
	self triggerEvent: #haApostado:en: with: aCarta with: aMesa.! !

!JugadorDelPrisionero privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self implementedBySubclass!

cooperar
	" Private - Devuelve la carta de cooperar. "

	^self cartas detect: [:one| one esCooperar ]!

desertar
	" Private - Devuelve la carta de desertar. "

	^self cartas detect: [:one| one esDesertar ]! !

!Lugar class publicMethods !

en: unLugar
	"Devuelve una instancia del receptor contenida en unLugar."

	^self new
		contenedor: unLugar;
		yourself! !

!Lugar class privateMethods !

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		addAll: #( lleno vacio llego: salio: );
		yourself! !

!Lugar publicMethods !

actores
	"Returns the instance var of the receiver
	 for external manipulation"

	actores isNil ifTrue: [ self initializeActores ].
	^actores!

algunVecino
	"Devuelve algun vecino del receptor.
	Si no tiene vecinos devuelve el receptor."

	self vecinos notEmpty
	ifTrue: [
		^self vecinos at: (self nextRandom * (self vecinos size - 1)) truncated + 1
	].!

casino
	"Devuelve el casino donde esta el receptor."

	| casino |
	casino := self contenedor.
	[ (casino respondsTo: #contenedor)
	  and: [casino contenedor notNil] ]
	whileTrue: [ casino := casino contenedor ].
	^casino!

clone
	"Devuelve un clon del receptor, sin conectar a nadie."

	^super clone
		initializeActores;
		initializeVecinos;
		yourself!

contenedor
	"Returns the instance var of the receiver
	 for external manipulation"
	^contenedor!

contenedor: aLugar
	"Sets the instance var of the receiver with aLugar."

	contenedor := aLugar.
	(aLugar respondsTo: #add:) ifTrue: [
		aLugar add: self
	].!

convocar: unLugar
	"El receptor debera convocar a sus actores a moverse a unLugar."

	self actores copy do: [:unActor|
		(unLugar puedeContener: unActor)
		ifTrue: [ unActor puedeMoverseA: unLugar ].
	].!

convocarVecinos
	"El receptor invita a sus actores a salir a un pasillo."

	self vecinosDesordenados do: [:unLugar|
		unLugar estaLleno ifTrue: [ ^self ].
		self convocar: unLugar.
	].!

donacionDe: unJugador a: otro de: puntaje
	"Efectua la donacion de un determinado puntaje de unJugador a otro."

	^self casino donacionDe: unJugador a: otro de: puntaje!

esLugar
	"Devuelve true si el receptor es un lugar."

	^true!

esMesa
	"Devuelve true si el receptor es una mesa."

	^false!

esPasillo
	"Devuelve true si el receptor es un pasillo."

	^false!

estaLleno
	"Devuelve true si el receptor esta lleno (no puede permitir el ingreso de otros actores).
	La respuesta default es false (por lo que el receptor tiene cupo inlimitado).
	Este metodo puede ser refinado por subclases."

	^false!

estaVacio
	"Devuelve true si el receptor esta vacio."

	^actores size = 0!

lindaCon: aLugar
	"Devuelve true si el receptor linda con aLugar."

	^self vecinos includes: aLugar!

necesitaUnaBanca
	"El receptor NO necesita una banca."

	^false!

procreo: aJugador
	" unJugador desea procrear.
	Verifica que este pueda hacerlo.
	Devolvera el hijo si tiene exito; sino devuelve nil."

	^self casino procreo: aJugador!

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	La respuesta default es true (por lo que el receptor tiene cupo inlimitado).
	Este metodo puede ser refinado por subclases."

	^true!

puedeProcrear: aJugador
	"Devuelve true cuando aJugador puede procrear."

	^self casino puedeProcrear: self!

puedeSerVecinoDe: aLugar
	"Deve devolver true si el receptor puede ser vecino de aLugar.
	La accion default es devolver true; este metodo puede ser refinado por las subclases."

	^true!

puntajeDe: unJugador
	"Devuelve el puntaje de unJugador."

	^self casino puntajeDe: unJugador!

step
	"Da un paso en la simulacion del receptor.
	Si el receptor tiene actores tratara de inducirlos a salir a un pasillo."

	super step.
	self convocarVecinos.!

vecinos
	"Returns the instance var of the receiver
	 for external manipulation"

	vecinos isNil ifTrue: [ self initializeVecinos ].
	^vecinos!

vecinosDesordenados
	"Devuelve los vecinos del receptor en un orden aleatorio."

	^self randomize: self vecinos! !

!Lugar privateMethods !

initializeActores
	" Private - Initializes the receiver's actores"

	actores := OrderedCollection new.!

initializeVecinos
	" Private - Initializes the receiver's vecinos"

	vecinos := OrderedCollection new.!

llego: unActor
	" Private - unActor llego al receptor. "

	self actores add: unActor.
	self triggerEvent: #llego: with: unActor.
	self estaLleno ifTrue: [
		self triggerEvent: #lleno
	].
	self changed.!

salio: unActor
	" Private - unActor salio del receptor. "

	self actores remove: unActor ifAbsent: [ self error: 'El ',unActor class name,' no estaba aqui.' ].
	self triggerEvent: #salio: with: unActor.
	self estaVacio ifTrue: [ self triggerEvent: #vacio ].
	self changed.! !

!LugarGUI publicMethods !

displayWith: aPen
	"Display the receiver with aPen."

	aPen isNil ifTrue: [ ^self ].
	super displayWith: aPen.
	self displayActoresWith: aPen.!

imageForBanca: aBanca
	" Returns the receiver's banca image. "

	| state |
	state := #( shy amazed frown smile tongue )
		detect: [:one| aBanca is: one ]
		ifNone: [#shy].
	^self imageNamed: 'Banca-',state! !

!LugarGUI privateMethods !

displayActoresWith: aPen
	" Private - Muestra los actores con aPen.
	La accion default es disponer los actores en orden mientras se pueda."

	| stream place image |
	stream := ReadStream on: self model actores asArray.
	place := self left @ self top.
	[ stream atEnd ] whileFalse: [
		image := self imageFor: stream next.
		place x + image width - 1 > self right
		ifTrue: [ place x: self left; y: place y + image height + 1 ].
		place y + image height > self bottom ifTrue: [
			aPen
				fill: (self leftBottom +(1@-2) rightBottom: self rightBottom+(-1@0))
				color: "ClrRed" 16777229 "Color red".
			^self
		].
		image displayAt: place with: aPen.
		place x: place x + image width + 1
	].!

imageFor: aJugador
	" Private - Devuelve una imagen apropiada para mostrar aJugador. "

	| aName state |
	aJugador isNil ifTrue: [ ^nil ].
	aJugador esBanca ifTrue: [
		^self imageForBanca: aJugador
	].
	aName := String new.
	#(
		( shy amazed frown smile )
		( normal upset mad )
	) do: [:tuple|
		state := tuple
			detect: [:aState| aJugador is: aState ] ifNone: [ tuple first ].
		aName := aName,'-',state.
	].
	^self imageNamed: (aName copyFrom: 2 to: aName size)! !

!LugarNoHabitable publicMethods !

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	La respuesta es false."

	^false!

step
	"Da un paso en la simulacion del receptor.
	Si el receptor tiene actores tratara de inducirlos a salir a un pasillo.
	Si no lo desean, los obligara a hacerlo."

	| stream |
	super step.
	self vecinos isEmpty ifTrue: [ ^self ].
	stream := ReadStream on: (self vecinos"Desordenados" select: [:one| one estaLleno not ]) asArray.
	stream atEnd ifTrue: [ ^self ].
	self actores copy do: [:each|
		stream atEnd ifTrue: [ stream reset ].
		each lugar: stream next.
	].! !

!MesaDeJuegos class privateMethods !

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		addAll: #(
			iniciandoRonda apuestasRealizadas
			apuestasEvaluadas juegoAbierto
			convocandoJugadores finalizandoRonda
		);
		yourself! !

!MesaDeJuegos publicMethods !

abrirJuego
	" El receptor debe abrir el juego para una nueva ronda. "

	self banca abrirJuego.
	self triggerEvent: #juegoAbierto.!

aceptarJugadores
	" El receptor puede convocar nuevos jugadores.
	La accion default es convocar nuevos jugadores de los lugares vecinos.
	Este metodo puede ser refinado por las subclases."

	self triggerEvent: #convocandoJugadores.
	self pasillos do: [:unLugar| unLugar convocar: self ].!

apuestas
	"Devuelve las apuestas que estan sobre el receptor,
	como una colecction de pares #( jugador apuesta ). "

	^banca notNil
	ifTrue: [ self banca apuestas ]
	ifFalse: [ Array new ]!

banca
	"Returns the instance var of the receiver
	 for external manipulation"
	^banca!

banca: aBanca
	"Sets the instance var of the receiver and updates its place."

	aBanca == banca ifTrue: [ ^self ].
	aBanca notNil & banca notNil ifTrue: [ ^self error: 'Ya tenia una banca...' ].

	banca := aBanca.
	aBanca notNil ifTrue: [ aBanca lugar: self ].!

cerrarJuego
	" El receptor debe cerrar el juego de la ronda actual. "

	self banca cerrarJuego.
	self triggerEvent: #juegoCerrado.!

clone
	"Devuelve un clon del receptor, sin su banca."

	^super clone
		banca: nil;
		yourself!

convocar: unLugar
	"El receptor debera convocar a sus actores a moverse a unLugar."

	| aBanca |
	super convocar: unLugar.

	self estaVacio
	ifTrue: [
		self necesitaUnaBanca not
		ifTrue: [ self banca puedeMoverseA: unLugar ]
	]
	ifFalse: [
		(unLugar actores select: [:one| one esBanca ])
		do: [:each| each puedeMoverseA: self ]
	].!

esMesa
	"Devuelve true si el receptor es una mesa."

	^true!

estaLlena
	"Devuelve true si el receptor esta llena."

	^self estaLleno!

estaLleno
	"Devuelve true si el receptor esta lleno (no puede permitir el ingreso de otros actores)."

	^self jugadores size >= self cantidadDeLugares!

evaluarApuestas
	" El receptor puede evaluar las apuestas realizadas en esta ronda. "

	self banca
		evaluarApuestas;
		notificarApuestas.
	self triggerEvent: #apuestasEvaluadas.
	self changed.!

jugadores
	"Devuelve los actores hubicados en el receptor."

	^self actores!

jugar
	"Juega una ronda con los jugadores que tenga."

	self iniciarRonda.
	self puedeJugar
	ifTrue: [
		self
			abrirJuego;
			permitirApostar;
			cerrarJuego;
			evaluarApuestas
	].
	self
		aceptarJugadores;
		finalizarRonda;
		yourself.!

necesitaUnaBanca
	"Devuelve true si el receptor necesita una banca."

	^banca isNil!

pasillos
	"Devuelve los pasillos que lindan con el receptor."

	^self vecinos!

permitirApostar
	" El receptor debe permitir apostar a los jugadores. "

	self banca permitirApostar.
	self triggerEvent: #apuestasRealizadas.
	self changed.!

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	Acepta jugadores que quieran jugar el juego."

	unActor esBanca ifTrue: [ ^self necesitaUnaBanca ].
	^unActor quiereJugarEn: self!

puedeJugar
	" El receptor debe responder si en este momento puede realizar una ronda.
	La accion default es responder true si hay algun jugador y un representante de la banca que desee jugar.
	Este metodo puede ser reimplementado por las subclases."

	self permitirAbandono: self jugadores copy.
	^self jugadores size = self cantidadDeLugares
	and: [ self necesitaUnaBanca not
	and: [ self banca quiereJugarEn: self ]]!

puntajes
	"Devuelve los puntajes de los jugadores que estan jugando en el receptor."

	^self jugadores collect: [:each|
		Array
			with: each
			with: (self puntajeDe: each)
		]!

step
	"Da un paso en la simulacion del receptor."

	super step.

	" Las bancas saldran del home cada tanto. "
	"
	(self necesitaUnaBanca and: [ self estaLlena ])
	ifTrue: [ self banca: self bancaClass new ].
	"

	self jugar.! !

!MesaDeJuegos privateMethods !

bancaClass
	" Private - Devuelve la clase que puede ser banca del receptor."

	^self implementedBySubclass!

cantidadDeLugares
	" Private - Devuelve la catidad de lugares donde pueden hubicarse los jugadores.
	Esto limita la cantidad de jugadores que pueden estar jugando.
	Este mensaje debe ser implementado por las subclases "

	^self implementedBySubclass!

finalizarRonda
	" Private - Se finaliza la nueva ronda.
	La accion default es delegar en la banca.
	Este mensaje puede ser refinado por las subclases."

	self triggerEvent: #finalizandoRonda.
	self banca notNil ifTrue: [
		self banca finalizarRonda
	].!

iniciarRonda
	" Private - Se inicia una nueva ronda.
	La accion default es delegar la accion en la banca.
	Este mensaje puede ser refinado por las subclases."

	self triggerEvent: #iniciandoRonda.
	self banca notNil ifTrue: [
		self banca iniciarRonda
	].!

llego: unActor
	" Private - El receptor debe aceptar el ingreso de unActor.
	El receptor dejara entrar jugadores hasta que este lleno. "

	unActor esBanca ifTrue: [ ^self banca: unActor ].

	self estaLleno ifTrue: [
		self error: 'La mesa no acepta mas jugadores.'
	].
	^super llego: unActor!

permitirAbandono: aCollection
	" Private - Permite el abandono de los jugadores en aCollection que lo deseen. "

	aCollection do: [:aJugador|
		(aJugador quiereJugarEn: self)
		ifFalse: [
			self pasillos detect: [:aPasillo|
				aJugador puedeMoverseA: aPasillo.
				aJugador lugar == self "se movio"
			] ifNone: [
				"no quiere jugar, pero tampoco se quiso retirar...
				 entonces aqui se queda."
			].
		].
	].!

salio: unActor
	" Private - unActor salio del receptor. "

	unActor == self banca ifTrue: [
		self banca: nil.
		^self changed
	].
	^super salio: unActor! !

!MesaDeJuegosGUI publicMethods !

image
	" Returns the receiver's background image. "

	^self imageNamed: 'Mesa'! !

!MesaDeJuegosGUI privateMethods !

banca
	" Private - devuelve la banca del modelo del receptor. "

	^self model banca!

bancaOffset
	" Private - Devuelve el offset de la banca en la imagen receptor. "

	^38@1!

displayActoresWith: aPen
	" Private - Muestra los actores con aPen. "

	self
		displayBancaWith: aPen;
		displayJugadoresWith: aPen;
		displayApuestasWith: aPen;
		yourself.!

displayApuestasWith: aPen
	" Private - Muestra las apuestas con aPen. "

	| apuestas jugadores apuesta |
	apuestas := self model apuestas.
	apuestas isEmpty ifTrue: [ ^self ].
	jugadores := self model jugadores.
	1 to: jugadores size do: [:i|
		apuesta := apuestas at: (jugadores at: i) ifAbsent: [].
		apuesta notNil ifTrue: [
			(self image: i forApuesta: apuesta)
				displayAt: self leftTop + (self offsetForApuesta: i)
				with: aPen
		].
	].!

displayBancaWith: aPen
	" Private - Muestra la banca con aPen. "

	self banca isNil ifTrue: [ ^self ].
	(self imageForBanca: self banca)
		displayAt: self leftTop + self bancaOffset
		with: aPen!

displayJugadoresWith: aPen
	" Private - Muestra los jugadores con aPen. "

	| jugadores offsets imagen |
	jugadores := self model jugadores asArray.
	offsets := ReadStream on: (self offsetsFor: jugadores).
	jugadores do: [:jugador|
		imagen := self imageFor: jugador.
		imagen notNil
		ifTrue: [
			imagen
				displayAt: self leftTop + offsets next
				with: aPen
		]
	].!

image: index forApuesta: aApuesta
	" Private - Devuelve la imagen index de la apuesta aApuesta. "

	^self imageNamed: aApuesta class name,'-',index printString!

offsetForApuesta: index
	" Private - Devuelve el offset de la apuesta[index] en la imagen receptor. "

	^(Array
		with: 2@2
		with: 72@2
		) at: index!

offsetsFor: jugadores
	" Private - Devuelve los offsets para mostrar jugadores."

	^self implementedBySubclass! !

!MesaDelPrisionero publicMethods !

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	Solo se acepta jugadores con plata y que quieran jugar el juego."

	(self tieneCredito: unActor) ifFalse: [ ^false ].
	^super puedeContener: unActor!

puedeJugar
	" El receptor debe responder si en este momento puede realizar una ronda."

	^super puedeJugar and: [ self estaLleno ]! !

!MesaDelPrisionero privateMethods !

bancaClass
	" Private - Devuelve la clase que puede ser banca del receptor."

	^BancaDelPrisionero!

cantidadDeLugares
	" Private - Devuelve la catidad de lugares donde pueden hubicarse los jugadores.
	Esto limita la cantidad de jugadores que pueden estar jugando."

	^2!

iniciarRonda
	" Private - Se inicia una nueva ronda.
	Se eliminaran de la mesa los jugadores sin dinero."

	| stream aLugar |
	super iniciarRonda.
	(stream := ReadStream on: self vecinosDesordenados) atEnd
	 ifTrue: [ ^self ]. "no hay donde mandarlos..."

	(self jugadores select: [:one| (self tieneCredito: one) not ])
	do: [:each|
		stream atEnd ifTrue: [ stream reset ].
		aLugar := stream next.
		aLugar estaLleno ifFalse: [ each lugar: aLugar ].
	].!

tieneCredito: aJugador
	" Private - Devuelve true si aJugador tiene credito. "

	^aJugador esJugador and: [ (self puntajeDe: aJugador) >= 0 ]! !

!MesaDelPrisioneroGUI privateMethods !

offsetsFor: jugadores
	" Private - Devuelve los offsets para mostrar jugadores."

	^Array
		with: 2@23
		with: 75@23! !

!MoveController publicMethods !

button1Down: aPane
	"El mouse se ha presionado sobre aPane.
	Detecta el objeto a mover."

	super button1Down: aPane.
	moved := self objectUnderCursor.
	moved canBeMoved ifFalse: [ ^moved := nil ].!

button1Moved: aPane
	"El mouse se ha movido mientras estaba presionado sobre aPane."

	super button1Moved: aPane.
	moved notNil ifTrue: [
		moved centerAt: self mouseLocation.
		self updateView.
	].!

clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	super clicked: aPane.
	self button1Moved: aPane.
	moved := nil.! !

!Pared publicMethods !

estaLleno
	"Devuelve true si el receptor esta lleno."

	^true! !

!Pasillo publicMethods !

esPasillo
	"Devuelve true si el receptor es un pasillo."

	^true! !

!PasilloGUI publicMethods !

canBeMoved
	"El receptor nopuede moverse graficamente;
	pues este se adapta graficamente a los objetos que contiene."

	^true"self model vecinos isEmpty"!

defaultExtent
	"Devuelve el extent default para el receptor."

	^self defaultWidth @ self defaultHeight!

defaultHeight
	"Devuelve el alto default para el receptor."

	^layout = #horizontal
	ifTrue: [ (self imageNamed: 'Banca-shy') height ]
	ifFalse: [ (self imageNamed: 'mesa') height ]!

defaultWidth
	"Devuelve el ancho default para el receptor."

	^layout = #horizontal
	ifTrue: [ (self imageNamed: 'mesa') width ]
	ifFalse: [ (self imageNamed: 'Banca-shy') width ]!

displayWith: aPen
	"Display the receiver with aPen."

	aPen isNil ifTrue: [ ^self ].
	super displayWith: aPen.
	aPen
		place: self leftTop;
		box: self rightBottom;
		yourself.!

isTransparent
	"Returns true if the receiver is transparent."

	^false!

layout
	"Returns the instance var of the receiver
	 for external manipulation"

	layout isNil ifTrue: [ self initializeLayout ].
	^layout!

layout: aSymbol
	"Sets the instance var of the receiver."

	| extent |
	layout := aSymbol.
	extent := self defaultExtent.
	self boundingBox: (self center - (extent  // 2) extent: extent).!

rotate
	"Rota el receptor 90 grados"

	layout = #horizontal
	ifTrue: [ self layout: #vertical ]
	ifFalse: [ self layout: #horizontal ].
	self updateView.! !

!PasilloGUI privateMethods !

initializeLayout
	" Private - Initializes the receiver's layout"

	layout := #horizontal.! !

!PrisionCoordinator class privateMethods !

constructEventsTriggered
	"Private - Construct the set of events triggered by instances of the receiver."

	^super constructEventsTriggered
		add: #modelHasChanged;
		yourself! !

!PrisioneroApp class privateMethods !

abtIsViewApplication

	^true! !

!PrisionModel publicMethods !

clone
	"Devuelve un clon del receptor."

	^self copy!

esJugador
	"Devuelve true si el receptor es un jugador."

	^false!

esLugar
	"Devuelve true si el receptor es un lugar."

	^false!

nextRandom
	"Devuelve un numero aleatorio entre 0 y 1."

	^self random next!

random
	"Devuelve un generador de numeros aleatorios entre 0 y 1."

	^Random default!

randomize: aCollection
	"Devuelve una coleccion con los elementos de aCollection en un orden aleatorio."

	| result remaining index |
	result := OrderedCollection new.
	remaining := aCollection asOrderedCollection copy.
	[remaining notEmpty] whileTrue: [
		index := (self nextRandom * (remaining size - 1)) truncated + 1.
		result add: (remaining remove: (remaining at: index))
	].
	result size = aCollection size ifFalse: [ ^aCollection"^self error: 'Randomizacion con errores.'" ].
	^result!

step
	"Da un paso en la simulacion del receptor.
	La accion default es no hacer nada.
	Este metodo puede ser refinado por las subclases."! !

!PrisionObject class publicMethods !

canTriggerEvent: eventName
		"Answer whether instances of the receiver can trigger
		 an event named <eventName>."
	^self eventsTriggered includes: eventName asSymbol!

confirm: question
	" Open a message box with question."

	^AbtMessagePrompter new
		title: 'Confirme';
		buttonType: (CwConstants at: 'XmYESNO');
		iconType: (CwConstants at: 'XmICONINFO');
		messageString: question;
		prompt!

eventsTriggered
		"Answer all the events which can be triggered
		by instances of the receiver."
	^self constructEventsTriggered!

warning: message
	" Warns a message box with the message."

	^AbtMessagePrompter new
		title: 'Warning';
		buttonType: (CwConstants at: 'XmOK');
		iconType: (CwConstants at: 'XmICONINFO');
		messageString: message;
		prompt! !

!PrisionObject class privateMethods !

constructEventsTriggered
		"Private - answer the set of events that instances of the
		receiver can trigger."
	^Set with: #changed! !

!PrisionObject publicMethods !

actionForEvent: eventName
		"Answer the action to evaluate when the event
		named <eventName> is triggered by the receiver."
	^self eventTable
		at: eventName asSymbol
		ifAbsent: [nil]!

actionListForEvent: eventName
		"Answer an editable list of actions that get evaluated
		when the event named <eventName> is triggered."
	^self eventTable
		at: eventName asSymbol
		ifAbsent: [^#()]!

addDependent: anObject interestIn: anAspect
	"Add a dependent <anObject> that receives an update event when the event named <anAspect> is triggered."

	self
		when: anAspect
		send: #update
		to: anObject!

asString
	^self printString!

canTriggerEvent: eventName
		"Answer <true> if the receiver can trigger an event
		named <eventName>."
	^self class canTriggerEvent: eventName!

changed
		"The receiver changed in some general way.
		Inform all of the receiver's dependents by sending
		each dependent an update message."
	self triggerEvent: self changedEventName!

confirm: question
	" Open a message box with question."

	^self class confirm: question!

evaluate: anObject withArguments: anArray
		"Answer the result of evaluating anObject."

	anObject isNil ifTrue: [ ^nil ].

	anObject isContext
	ifTrue: [
		anArray isEmpty ifTrue: [ ^anObject value ].
		anArray size = 1 ifTrue: [ ^anObject value: anArray first ].
		anArray size = 2 ifTrue: [ ^anObject value: anArray first value: anArray last ].
		^self error: 'invalid argument count.'
	].
	(anObject isKindOf: Message) ifTrue: [
		^anObject receiver
			perform: anObject selector
			withArguments: (self collect: anObject arguments: anArray)
	].

	anObject isArray ifTrue: [
		anObject do: [:each| self evaluate: each withArguments: anArray  ].
		^self
	].

	^self error: 'must not happen.'!

numberOfArgumentsFor: aSelector
		"Answer the number of arguments required by a message whose
		selector is <aSelector>, assuming <aSelector> is a legal
		method selector."
	aSelector first isLetter
		ifTrue: [ ^aSelector occurrencesOf: $: ].
   ( #(
		 = ~= == ~~ > >= < <=   " comparison operations "
		+ - *  / \\  //                    " arithmetic operations "
	   & |                                 " logical operations "
	   @ ,                                " miscellaneous "
		) includes: aSelector asSymbol)
			ifTrue: [^1].
	^aSelector occurrencesOf: $:!

removeActionsForEvent: eventName
		"Remove all actions for the event named <eventName>."
	| table |
	table := self eventTable.
	table removeKey: eventName asSymbol ifAbsent: [].!

setActionList: actionSequence forEvent: eventName
		"Set the list of actions that get evaluated when
		the event named <eventName> is triggered by
		the receiver to <actionSequence>."
	| action |
	action := actionSequence "asMinimalRepresentation".
	action == nil
		ifTrue: [ self removeActionsForEvent: eventName ]
		ifFalse: [
			self eventTable
				at: eventName asSymbol
				put: action ]!

triggerEvent: eventName
		"Trigger the event named <eventName>. Answer the value returned
		by the most recently defined event handler action."
   ^self evaluate: (self actionForEvent: eventName) withArguments: #()!

triggerEvent: eventName with: argument
		"Trigger the event <eventName> using the given
		<argument> as the argument.  Answer the value
		returned by the most recently defined event handler action."
	^self
		triggerEvent: eventName
		withArguments: (Array with: argument)!

triggerEvent: eventName with: firstArgument with: secondArgument
		"Trigger the event <eventName> using the <firstArgument>
		and <secondArgument> as the arguments.  Answer the
		value returned by the most recently defined event
		handler action."
	^self
		triggerEvent: eventName
		withArguments: (Array
			with: firstArgument
			with: secondArgument)!

triggerEvent: eventName withArguments: argumentList
		"Trigger the event <eventName> using the
		elements of the <argumentList> as the arguments.
		Answer the value returned by the most recently
		defined event handler action."
	^self
		evaluate: (self actionForEvent: eventName)
		withArguments: argumentList!

warning: message
	" Warns a message box with the message."

	^self class warning: message!

when: eventName evaluate: anAction
		"Append <anAction> to the list of actions to evaluate
		when the receiver triggers the event named <eventName>."
	| actions |
	(self canTriggerEvent: eventName)
		ifFalse: [self errorBadEvent: eventName].
	actions := self actionListForEvent: eventName.
	(actions includes: anAction) ifTrue: [^self].
	self
		setActionList: (actions copyWith: anAction)
		forEvent: eventName!

when: eventName send: selector to: anObject
		"Form an action with <anObject> as the receiver and
		a <selector> as the message selector and append
		it to the actions list for the event named <eventName>."
   | arguments |
	selector isSymbol
		ifFalse: [^self errorBadSelector: selector].
	arguments := Array new: (self numberOfArgumentsFor: selector).
	self
		when: eventName
		evaluate:
			(Message new
				receiver: anObject;
				selector: selector;
				arguments: arguments;
				yourself)!

when: eventName send: selector to: anObject with: argument
		"Form an action with <anObject> as the receiver,
		a <selector> as the message selector, and <argument>
		as the argument and append it to the actions
		list for the event named <eventName>."
	self
		when: eventName
		send: selector
		to: anObject
		withArguments: (Array with: argument)!

when: eventName send: selector to: anObject with: firstArgument with: secondArgument
		"Form an action with <anObject> as the receiver,
		a <selector> as the message selector, and the
		<firstArgument> and <secondArgument> as the
		arguments and append it to the actions
		list for the event named <eventName>."
	self
		when: eventName
		send: selector
		to: anObject
		withArguments:
			(Array with: firstArgument with: secondArgument)!

when: eventName send: selector to: anObject withArguments: argumentList
		"Form an action with <anObject> as the receiver,
		a <selector> as the message selector, and the
		elements of the <argumentList> as the arguments
		and append it to the actions list for the event
		named <eventName>."
	| arguments |
	selector isSymbol
		ifFalse: [^self errorBadSelector: selector].
	arguments := Array new: (self numberOfArgumentsFor: selector).
	arguments
		replaceFrom: 1
		to: (arguments size min: argumentList size)
		with: argumentList
		startingAt: 1.
	self
		when: eventName
		evaluate:
			(Message
				receiver: anObject
				selector: selector
				arguments: arguments)! !

!PrisionObject privateMethods !

changedEventName
		"Private - answer the name of the event to generate when a
		changed message is received."
	^#changed!

collect: aMessage arguments: evaluationArguments
		"Private - answer the action arguments with which to evaluate
		the receiver, collecting from the <evaluationArguments>
		and the predefined arguments in the receiver. "
	| predefinedArgs |
	predefinedArgs := aMessage arguments.
	^(evaluationArguments size = predefinedArgs size)
		ifTrue: [evaluationArguments]
		ifFalse:
			[( predefinedArgs isNil
				ifTrue: [ predefinedArgs := Array new: (self numberOfArgumentsFor: aMessage selector) ]
				ifFalse: [predefinedArgs copy] )
					replaceFrom: 1
					to: (evaluationArguments size min: predefinedArgs size)
					with: evaluationArguments
					startingAt: 1]!

errorBadEvent: eventName
		"Private - signal an unsupported event."
	^self error: 'Event not supported: ', eventName!

errorBadSelector: badSelector
		"Private - indicate that the message selector is not valid."
	self error: 'Message selector ', badSelector printString, ' must be a Symbol.'!

eventTable
	"Private"
	"Answer a Dictionary mapping event names to actions
	for the receiver."

	^handlers == nil
		ifTrue: [self eventTableCreate]
		ifFalse: [handlers]!

eventTableCreate
		"Private - answer an empty dictionary for use as an event table."
	^handlers := IdentityDictionary new!

eventTableForEdit
	"Private"
	"Answer a Dictionary mapping event names to actions,
	allocate it if necessary."

	handlers == nil
		ifTrue: [handlers := self eventTableCreate].
	^handlers!

releaseEventTable
	"Private - break all connections to event handlers."

	handlers := nil! !

!Puerta publicMethods !

estaLleno
	"Devuelve true si el receptor esta lleno."

	^false!

puedeContener: unActor
	"Devuelve true si el receptor soporta el ingreso de unActor en este momento.
	Solo se acepta jugadores indeseables."

	^unActor esJugador and: [ self esIndeseable: unActor ]!

step
	"Da un paso en la simulacion del receptor.
	Si el receptor tiene vecinos con actores sin dinero; los atraera a salir del casino."

	self vecinos notEmpty ifTrue: [
		self vecinos do: [:aLugar|
			(aLugar actores select: [:each| self esIndeseable: each ])
			do: [:condenado| condenado lugar: self ].
		].
	].
	super step.! !

!Puerta privateMethods !

esIndeseable: unActor
	" Private - Devuelve true si el receptor es indeseable para el casino y debera ser expulsado. "

	^unActor esJugador and: [ (self puntajeDe: unActor) <= 0 ]!

llego: unActor
	" Private - unActor llego al receptor. "

	unActor esJugador ifFalse: [
		^self error: 'Por aqui solo puede salir un jugador.'
	].

	self casino remove: unActor.
	self triggerEvent: #llego: with: unActor.
	"Quienes llegan a la puerta son olvidados"!

nuevoJugador: unActor
	" Private - unActor llego al receptor. "

	self actores add: unActor.
	unActor privateLugar: self.
	self changed.! !

!PuertaGUI privateMethods !

createElement
	" Private - Creates a new jugador."

	| anElement |
	anElement := self basicCreateElement.
	anElement notNil ifTrue: [ self model nuevoJugador: anElement ].!

initializeClasses
	" Private - Initializes the receiver's classes"

	classes := (JugadorDelPrisionero allSubclasses
			collect: [:each| each symbol ])
			asOrderedCollection! !

!Random class publicMethods !

default

	Default isNil ifTrue: [ self initializeDefault ].
	^Default! !

!Random class privateMethods !

initializeDefault

	Default := self new! !

!Random publicMethods !

next
	"Returns the rext value of the receiver."

	esRandom isNil ifTrue: [ esRandom := EsRandom new ].
	^esRandom next! !

!RemoveController publicMethods !

clicked: aPane
	"El mouse se ha dejado de presionar sobre aPane."

	| object |
	super clicked: aPane.
	object := self objectUnderCursor.
	(object notNil and: [ object ~= model ])
	ifTrue: [
		self mark: object.
		(self confirm: 'Seguro desea eliminar : ',object printString)
		ifTrue: [ self model remove: object ].
		self updateView.
	].! !

!Rencoroso publicMethods !

defraudado
	"Returns the instance var of the receiver
	 for external manipulation"

	defraudado isNil ifTrue: [ self initializeDefraudado ].
	^defraudado!

defraudado: anObject
	"Sets the instance var of the receiver
	 with anObject. (No checking is done)"
	defraudado := anObject!

multa: puntaje
	"El receptor debe aceptar la multa del puntaje que se le otorga.
	El receptor se siente defraudado si alguna vez es multado."

	super multa: puntaje.
	self defraudado: true.! !

!Rencoroso privateMethods !

cartaAJugarEn: aMesa
	" Private - El receptor debe decidir que carta jugar en aMesa. "

	^self defraudado
	ifTrue: [ self desertar ]
	ifFalse: [ self cooperar ]!

initializeDefraudado
	" Private - Initializes the receiver's defraudado"

	defraudado := false.! !

PrisionObject initializeAfterLoad!
GUIObject initializeAfterLoad!
GUIController initializeAfterLoad!
ConnectController initializeAfterLoad!
DefaultController initializeAfterLoad!
MoveController initializeAfterLoad!
AlignController initializeAfterLoad!
RemoveController initializeAfterLoad!
GUIView initializeAfterLoad!
GUIComposite initializeAfterLoad!
CasinoGUI initializeAfterLoad!
LugarGUI initializeAfterLoad!
FactoryGUI initializeAfterLoad!
CasaDelTesoroGUI initializeAfterLoad!
PuertaGUI initializeAfterLoad!
MesaDeJuegosGUI initializeAfterLoad!
MesaDelPrisioneroGUI initializeAfterLoad!
PasilloGUI initializeAfterLoad!
PrisionCoordinator initializeAfterLoad!
PrisionModel initializeAfterLoad!
Actor initializeAfterLoad!
Banca initializeAfterLoad!
BancaDeCartas initializeAfterLoad!
BancaDelPrisionero initializeAfterLoad!
Jugador initializeAfterLoad!
JugadorDeCartas initializeAfterLoad!
JugadorDelPrisionero initializeAfterLoad!
Aleatorio initializeAfterLoad!
AlgoCooperador initializeAfterLoad!
Cooperador initializeAfterLoad!
Desertor initializeAfterLoad!
DondeLasDanLasToman initializeAfterLoad!
CandidoProbador initializeAfterLoad!
Rencoroso initializeAfterLoad!
Carta initializeAfterLoad!
CartaDelPrisionero initializeAfterLoad!
Cooperar initializeAfterLoad!
Desertar initializeAfterLoad!
Casino initializeAfterLoad!
Lugar initializeAfterLoad!
LugarNoHabitable initializeAfterLoad!
CasaDelTesoro initializeAfterLoad!
Pared initializeAfterLoad!
Puerta initializeAfterLoad!
MesaDeJuegos initializeAfterLoad!
MesaDelPrisionero initializeAfterLoad!
Pasillo initializeAfterLoad!
Random initializeAfterLoad!
PrisioneroApp initializeAfterLoad!

PrisioneroApp loaded!